/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#ifndef _CASP_BSP_WIRE_H_
#define _CASP_BSP_WIRE_H_

#include "sam_hwd.h"

//i2c transmission error status as per Arduino Wire Library
#define TWIRE_TRANS_SUCCESS     0
#define TWIRE_TRANS_DATA_OVFLOW 1//data too long to fit in transmit buffer
#define TWIRE_TRANS_TX_NACK     2//received NACK on transmit of address
#define TWIRE_TRANS_RX_NACK     3//received NACK on transmit of data
#define TWIRE_TRANS_UNKNOWN_ERR 4//other error

#define TWI_BUFFER_LENGTH   64

class TwoWire
{
public:
    TwoWire();
    ~TwoWire();
    void begin(_BYTE address = 0, _BYTE i2c = 1);
    void end(void);
    void setClock(_DWORD);
    void beginTransmission(_BYTE);
    _BYTE endTransmission(_BYTE sendStop = TRUE);
    _BYTE requestFrom(_BYTE address, _BYTE quantity, _BYTE sendStop = 1);
    unsigned int write(_BYTE);
    unsigned int write(const _BYTE *, unsigned int);
    int available(void);
    int read(void);
    int peek(void);
    void onReceive( void (*)(int) );
    void onRequest( void (*)(void) );
private:
    //
    void (*user_onRequest)(void);
    void (*user_onReceive)(int);
};
extern TwoWire Wire;

#endif//_CASP_BSP_WIRE_H_
