/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#include "sam_hwd.h"
#include "SPI.h"

SpiComm SPI;
SpiComm::SpiComm(const _UINT32 spi_base_clk):m_spi_base_clk(spi_base_clk)
{
    m_msb_first = 1;
}
SpiComm::~SpiComm()
{
}
void SpiComm::begin()
{
}
void SpiComm::end()
{
}
void SpiComm::setClockDivider(const unsigned short div)
{
}
void SpiComm::setBitOrder(const unsigned char msb)
{
    m_msb_first = msb;
}
void SpiComm::beginTransaction(const SPISettings &settings)
{
    endTransaction();
    m_msb_first = settings._bitOrder;
}
void SpiComm::endTransaction()
{
}
void SpiComm::send(const unsigned char data)
{
    transfer(data);
}
unsigned char SpiComm::recv()
{
    return transfer(SPI_DUMMY_BYTE);
}
unsigned char SpiComm::transfer(const unsigned char data)
{
    return 0;
}
unsigned short SpiComm::transfer16(const unsigned short data)
{
    _BYTE lsb = transfer(data & 0xff);//lsb
    _BYTE msb = transfer((data>>8) & 0xff);//msb
    return (lsb | (msb << 8));
}
